/**
 * created by wy
 * 小易个人办公部分
 * 包含我的待办、申请、审批
 **/

/*----------------通用方法--------------*/
/*返回主页面*/
$(".use-easy-office-common-title img").click(function(){
    $(".use-easy-common-container").css("display","none");
    $(".use-easy-home-container").css("display","block");
})

/*------------------我的待办部分---------*/
var todoCurrentPage = 1;//当前页码
var todoPageSize=4;
var todoTotal=0;//待办数据条数
/*打开我的待办box*/
function showMyTodoBox(e){
    var url = $(e).attr("name");
    if(url){
        var dialog = $("#todoBox").kendoWindow({
            actions: ["Close"],
            width  : 800,
            height : 510,
            title  : '消息盒子',
            visible: false,
            iframe : true,
            modal  : true,
            content: url,
            close: function (e) {
                hlsWindowClose(this);
                //刷新todo列表
                todoCurrentPage=1;//重新从第一页开始查
                initMyTodoListTab();
                initMyListCount();//刷新我的申请待办审批条数
            }
        }).data("kendoWindow");
        hlsWindow(dialog,'FULL',contextPath+url+"&noticeBox=indexBox&functionCode=openNoticeBox");
    }
}
/*获取数据并渲染页面*/
function initMyTodoListTab(){
    var obj = $("#search-my-todo").val()||"";//查询条件
    var container = $(".use-easy-my-todo-item-container");//获取容器
    container.css("display","block");
    $.ajax({
        type: 'GET',
        url: contextPath+'/ease/system/noticeMessage/query?pagesize='+todoPageSize+'&page='+todoCurrentPage+'&noticeMessage='+obj,
        contentType: "application/json; charset=utf-8",
        async:false,
        success: function (datas) {
            var diff = minus(todoPageSize,datas.rows.length);//页面固定条数与查询结果条数差值
            if(diff>=0){
                var html='';
                var hour=0;
                var day =0;
                var week=0;
                var month=0;
                var year =0;
                for(var i=0;i<datas.rows.length;i++){
                    var times =datas.rows[i].arrivalTime + '小时 以前';
                    if(datas.rows[i].arrivalTime>24 && datas.rows[i].arrivalTime <168){
                        day = (datas.rows[i].arrivalTime/24).toFixed(0);
                        hour= (datas.rows[i].arrivalTime%24).toFixed(0);
                        times = day + '天' + hour + '小时以前';
                    }else if (datas.rows[i].arrivalTime>=168 && datas.rows[i].arrivalTime <720){
                        week = (datas.rows[i].arrivalTime/168).toFixed(0);
                        day = (datas.rows[i].arrivalTime%168/24).toFixed(0);
                        times = week + '周' + day + '天 以前';
                    }else if(datas.rows[i].arrivalTime>=720 && datas.rows[i].arrivalTime <8760){
                        month = (datas.rows[i].arrivalTime/720).toFixed(0);
                        week = (datas.rows[i].arrivalTime%720/168).toFixed(0);
                        times = month + '月' + week + '周 以前';
                    }else if (datas.rows[i].arrivalTime>=8760) {
                        year = (datas.rows[i].arrivalTime/8760).toFixed(0);
                        month = (datas.rows[i].arrivalTime%8760/720).toFixed(0);
                        times = year + '年' + month + '月 以前';
                    }
                    container.eq(i).find(".my-todo-item-time").text(times||'--');
                    container.eq(i).find(".my-todo-item-content").attr("name",datas.rows[i].notice_url).text(datas.rows[i].notice_message||'--');
                    container.eq(i).find(".my-todo-item-content")[0].setAttribute("onclick","showMyTodoBox(this)");
                    container.eq(i).find(".my-todo-item-sender").text(datas.rows[i].userName||'--');
                }
            }
            if(diff>0){
                //移除没内容的container
                if(diff==todoPageSize){
                    container.css("display","none");
                }else{
                    container.eq(3-diff).nextAll(".use-easy-my-todo-item-container").css("display","none");
                }
            }
            todoTotal = datas.total;
            //初始化分页按钮
            initPageBtn("todo");
        }
    });
}

/*-------------------我的申请部分---------*/
var applyCurrentPage=1;//我的申请当前页码
var applyPageSize=4;
var applyTotal=0;//我的申请总条数
var myApplyApproveStatus = "";
/*显示查询条件*/
$("#show-my-apply-setting").click(function(){
    $(".use-easy-my-apply-setting").css("display","block");
})
/*查询条件点击事件*/
$(".use-easy-apply-btn").click(function(){
    myApplyApproveStatus="";
    $(this).toggleClass("use-easy-my-apply-btn-selected");
    //查询
    var selectBtn = $(".use-easy-my-apply-btn-selected");//选中的按钮
    for(var i=0;i<selectBtn.length;i++){
        myApplyApproveStatus = myApplyApproveStatus+$(selectBtn[i]).attr("name")+"-";
    }
    applyCurrentPage=1;
    initMyApplyListTab();
})
/*获取数据并渲染页面*/
function initMyApplyListTab(){
    var obj = $("#search-my-apply").val();//查询条件
    var container = $(".use-easy-my-apply-item-container");//获取容器
    container.css("display","block");
    var url=contextPath+'/ease/my/application/query?pagesize='+applyPageSize+'&page='+applyCurrentPage;
    if(obj!=""&&obj!=null){
        url=url+'&description='+obj;
    }
    if(myApplyApproveStatus!=null&&myApplyApproveStatus!=""){
        url = url+'&approveStatus='+ myApplyApproveStatus;
    }
    $.ajax({
        type: 'GET',
        url:url,
        contentType: "application/json; charset=utf-8",
        async:false,
        success: function (datas) {
            var diff = minus(applyPageSize,datas.rows.length);//页面固定条数与查询结果条数差值
            if(diff>=0){
                for(var i=0;i<datas.rows.length;i++){
                   $(".my-apply-item-title").eq(i).text(datas.rows[i].title||'--');
                    $(".my-apply-item-content").eq(i).text(datas.rows[i].description||'--');
                    $(".my-apply-item-sender").eq(i).text(datas.rows[i].startUserName||'--');
                    $(".my-apply-item-title").eq(i).text(datas.rows[i].title||'--');
                    $(".my-apply-item-time-detail").eq(i).text(datas.rows[i].startTime||'--');
                    //修改状态显示 暂时写死 需要询问
                    if(datas.rows[i].approveStatus=="NEW"){
                        datas.rows[i].approveStatus = "新建"
                        $(".my-apply-item-status").eq(i).css("backgroundColor","#2EC3E8");
                    }else if(datas.rows[i].approveStatus=="APPROVING"){
                        datas.rows[i].approveStatus = "审批中"
                        $(".my-apply-item-status").eq(i).css("backgroundColor","#FFCD55");
                    }else if(datas.rows[i].approveStatus=="REJECT"||datas.rows[i].approveStatus=="REJECTED"){
                        datas.rows[i].approveStatus = "审批拒绝";
                        $(".my-apply-item-status").eq(i).css("backgroundColor","#FA6A4D");
                    }else if(datas.rows[i].approveStatus =="APPROVED"){
                        datas.rows[i].approveStatus = "审批通过"
                        $(".my-apply-item-status").eq(i).css("backgroundColor","#A0D469");
                    }
                    $(".my-apply-item-status").eq(i).text(datas.rows[i].approveStatus);
                }
            }
            if(diff>0){
                //移除没内容的container
                if(diff==applyPageSize){
                    container.css("display","none");
                }else{
                    container.eq(3-diff).nextAll(".use-easy-my-apply-item-container").css("display","none");
                }
            }
            applyTotal = datas.total;
            //初始化分页按钮
            initPageBtn("apply");
        }
    });
}

/*------------------------我的审批部分---------*/
var approveCurrentPage=1;//我的审批当前页码
var approvePageSize=4;
var approveTotal=0;//我的审批总条数
var myApproveStatus = "";
/*点击图标显示审批页面*/
function showApproveDoc(e){
    var procInstId = $(e).attr("name");
    //---调用消息盒子打开 但是这里有问题 当task已经结束的时候 传taskid并不能获取到审批表单 故此处直接暂时不传 待后续bug修改结束
    openDetailWin("/wfl/wfl_maintenance.view?taskId=0&currentProcessInstanceId="+procInstId,0,'Y','indexBox','functionCode');
}
/*显示查询条件*/
$("#show-my-approve-setting").click(function(){
    $(".use-easy-my-approve-setting").css("display","block");
})
/*查询条件点击事件*/
$(".use-easy-approve-btn").click(function(){
    myApproveStatus="";
    $(this).toggleClass("use-easy-my-approve-btn-selected");
    //查询
    var selectBtn = $(".use-easy-my-approve-btn-selected");//选中的按钮
    for(var i=0;i<selectBtn.length;i++){
        myApproveStatus = myApproveStatus+$(selectBtn[i]).attr("name")+"-";
    }
    approveCurrentPage=1;
    initMyApproveListTab();
})
/*获取数据并渲染页面*/
function initMyApproveListTab(){
    var obj = $("#search-my-approve").val();//查询条件
    var container = $(".use-easy-my-approve-item-container");//获取容器
    container.css("display","block");
    var url=contextPath+'/ease/my/approve/query?pagesize='+approvePageSize+'&page='+approveCurrentPage;
    if(obj!=""&&obj!=null){
        url=url+'&description='+obj;
    }
    if(myApproveStatus!=null&&myApproveStatus!=""){
        url = url+'&approveStatus='+ myApproveStatus;
    }
    $.ajax({
        type: 'GET',
        url:url,
        contentType: "application/json; charset=utf-8",
        async:false,
        success: function (datas) {
            var diff = minus(approvePageSize,datas.rows.length);//页面固定条数与查询结果条数差值
            if(diff>=0){
                for(var i=0;i<datas.rows.length;i++){
                    $(".my-approve-item-title").eq(i).text(datas.rows[i].title||'--');
                    $(".my-approve-item-content").eq(i).text(datas.rows[i].description||'--');
                    $(".my-approve-item-description").eq(i).text(datas.rows[i].approveStatus||'--');
                    $(".my-approve-item-bottom img").eq(i).attr("name",datas.rows[i].procInstId);
                    if(datas.rows[i].approveStatus=="拒绝"){
                        $(".my-approve-item-description").eq(i).css("color","#F97064");
                    }else{
                        $(".my-approve-item-description").eq(i).css("color","#A0D469");
                    }
                    $(".my-approve-item-time-detail").eq(i).text(datas.rows[i].startTime||'--');
                }
            }
            if(diff>0){
                //移除没内容的container
                if(diff==approvePageSize){
                    container.css("display","none");
                }else{
                    container.eq(3-diff).nextAll(".use-easy-my-approve-item-container").css("display","none");
                }
            }
            approveTotal = datas.total;
            //初始化分页按钮
            initPageBtn("approve");
        }
    });
}