/**
 * created by wy
 * 小易个人收藏以及我的设置部分
 * 包含我的收藏、收藏单据动态信息、我的设置
 **/


/*--------------------------------------定义全局变量---------------------------*/
var myCollectionsDs=[];//我的收藏数据源
var myCollectionFirstLetter=[];//我的收藏首字母数组
var myCollectionFirstLetterObj={};//我的收藏首字母对象

var collect_message_type = '';//单据类型 CON_CONTRACT 、PRJ_PROJECT 、HLS_BP_MASTER
var collect_message_id=0;//单据ID
var collectNoticeMessageDs=[];//收藏单据消息动态数据源
var collectMessageCurrentPage=1;//当前页码
var collectMessageTotal;//总条数
var collectMessagePageSize=4;//一页数量
/*--------------------------------------我的收藏部分----------------------------*/
/*-----获取数据列表数据源-----*/
function initMyCollectionList(){
    var obj = $("#search-my-collections").val();//查询条件
    var url=contextPath+'/ease/system/collection/query';
    if(obj!=""&&obj!=null){
        url=contextPath+'/ease/system/collection/query?description='+obj;
    }
    $.ajax({
        type: 'GET',
        url: url,
        contentType: "application/json; charset=utf-8",
        async:false,
        success: function (datas) {
            myCollectionsDs = datas.rows;
        }
    });
}
/*----获取首字母并去重----*/
function getCollectionFirstLetter(){
    myCollectionFirstLetterObj={};
    myCollectionFirstLetter=[];
    for(var i=0;i<myCollectionsDs.length;i++){
        var firstLetter="";
        if(myCollectionsDs[i].description.charAt(0) >= 'a' && myCollectionsDs[i].description.charAt(0) <= 'z'){
            firstLetter = myCollectionsDs[i].description.substring(0,1).toLocaleUpperCase();
        }else{
            firstLetter = convertToPy(myCollectionsDs[i].description).substring(0,1);
        }
        if(!myCollectionFirstLetterObj[firstLetter]){
            myCollectionFirstLetterObj[firstLetter] = [{
                description:myCollectionsDs[i].description,
                relationDocNoticeCount:myCollectionsDs[i].relationDocNoticeCount,
                relationDocumentCategory:myCollectionsDs[i].relationDocumentCategory,
                relationDocumentId:myCollectionsDs[i].relationDocumentId
            }];
            myCollectionFirstLetter.push(firstLetter);
        }else{
            //如果已有这个属性
            myCollectionFirstLetterObj[firstLetter].push({
                description:myCollectionsDs[i].description,
                relationDocNoticeCount:myCollectionsDs[i].relationDocNoticeCount,
                relationDocumentCategory:myCollectionsDs[i].relationDocumentCategory,
                relationDocumentId:myCollectionsDs[i].relationDocumentId
            });
        }
    }
}
/*------排序（按首字母升序排列）---------*/
var quickSort=function(arr){
    //如果数组长度小于等于1无需判断直接返回即可
    if(arr.length<=1){
        return arr;
    }
    var midIndex=Math.floor(arr.length/2);//取基准点
    var midIndexVal=arr.splice(midIndex,1);//取基准点的值,splice(index,1)函数可以返回数组中被删除的那个数arr[index+1]
    var left=[];//存放比基准点小的数组
    var right=[];//存放比基准点大的数组
    //遍历数组，进行判断分配
    for(var i=0;i<arr.length;i++){
        if(convertToPy(arr[i].description)<convertToPy(midIndexVal[0].description)){
            left.push(arr[i]);//比基准点小的放在左边数组
        }
        else{
            right.push(arr[i]);//比基准点大的放在右边数组
        }
    }
    //递归执行以上操作,对左右两个数组进行操作，直到数组长度为<=1；
    return quickSort(left).concat(midIndexVal,quickSort(right));
};
function sortMyCollection(){
    myCollectionsDs = quickSort(myCollectionsDs);
}
/*-----绘制页面-----*/
function initMyCollectionTab(){
    //-------添加字母列表
    var letter_html=[];
    for(var index=0;index<myCollectionFirstLetter.length;index++){
        letter_html.push('<p onclick="initCollectionLetterBtn(this)">'+myCollectionFirstLetter[index]+'</p>');
    }
    $(".collections-letter-content").empty();
    $(".collections-letter-content").append(letter_html.join(""));
    //计算高度
    var divHeight = mul(myCollectionFirstLetter.length,17);
    var divMargin = div(minus(350,divHeight),2);
    $(".collections-letter-content").css("margin-top",divMargin);
    //--------添加具体内容列表
    var text_html=[];
    for(var item in myCollectionFirstLetterObj){
        //添加字母span
        text_html.push('<span style="padding-left:10px;color:#03b3b2;display: block;height:16px;width:240px;margin-left:auto;margin-right:auto;border-bottom: 1px solid #cccccc" id="collection-letter-item-'+item+'">'+item+'</span>');
        //添加内容
        for(j=0;j<myCollectionFirstLetterObj[item].length;j++){
            var param="";
            var iconName="";
            if(myCollectionFirstLetterObj[item][j].relationDocumentCategory=="PRJ_PROJECT"){
                iconName="prj";
            }else if(myCollectionFirstLetterObj[item][j].relationDocumentCategory=="CON_CONTRACT"){
                iconName="con";
            }else{
                iconName="bp";
            }
            var titleIconSrc=contextPath+"/resources/images/MAIN/EASY/easy-collect-"+iconName+".png";
            var moreIconSrc = contextPath+"/resources/images/MAIN/EASY/easy-collect-more.png";
            var relationDocNoticeCount=myCollectionFirstLetterObj[item][j].relationDocNoticeCount;
            if(relationDocNoticeCount>99){
                relationDocNoticeCount=99;
            }
            if(relationDocNoticeCount>0){
                 param = '<div class="my-collenction-items" id="'+myCollectionFirstLetterObj[item][j].relationDocumentCategory+'-'+myCollectionFirstLetterObj[item][j].relationDocumentId+'"><img style="position:relative;top:-6px;" src="'+titleIconSrc+'"><p>'+myCollectionFirstLetterObj[item][j].description+'</p><span>'+relationDocNoticeCount+'</span><img style="position: relative;top:-6px;height:17px;cursor:pointer;width:17px;" src="'+moreIconSrc+'" onclick="showCollectNoticeMessage(this)"'+'></div>';
            }else{
                param = '<div class="my-collenction-items"><img style="position:relative;top:-6px;" src="'+titleIconSrc+'"><p>'+myCollectionFirstLetterObj[item][j].description+'</p></div>';
            }
            text_html.push(param);

        }
    }
    $(".collections-main-container").empty();
    $(".collections-main-container").append(text_html.join(""));
}
/*-----字母点击事件--*/
function initCollectionLetterBtn(e){
    var newHeight=0;
    var mainContainer = $(".use-easy-collections-content");//外部div
    if(e){
        var letter = $(e).html();//获取letter
        var scrollToContainer = mainContainer.find("#collection-letter-item-"+letter);//要滚动到的位置
        var newHeight = scrollToContainer.offset().top - mainContainer.offset().top + mainContainer.scrollTop();
    }
    mainContainer.animate({
        scrollTop: newHeight
    }, 800);
}
/*----点击查看消息动态事件----*/
function showCollectNoticeMessage(e){
    var message = $(e).parent().attr("id");//结果为"PRJ-10001"
    collect_message_type = message.split("-")[0];
    collect_message_id=message.split("-")[1];
    //隐藏我的收藏 打开消息动态
    $(".use-easy-collections-container").css("display","none");
    $(".use-easy-collect-notice-container").css("display","block");
    $(".search-collect-notice").val("");
    //获取数据 渲染页面
    collectMessageCurrentPage=1;
    initCollectNoticeMessageTab();
}

/*---------------------------------------消息动态部分------------------------------*/
/*返回我的收藏*/
$(".use-easy-collect-common-title img").click(function(){
    //关闭当前面板 打开主面板
    $(".use-easy-common-container").css("display","none");
    $(".use-easy-collections-container").css("display","block");
})
/*初始化分页按钮*/
function initCollectNoticePageBtn(){
    if(collectMessageTotal==0||collectMessageTotal<=collectMessagePageSize){
        //没有数据或者只有一页 全部为暗
        $("#collect_foot_btn_prev").attr("src",contextPath+"/resources/images/CSH/last.png");
        $("#collect_foot_btn_next").attr("src",contextPath+"/resources/images/CSH/nextNot.png");
    }
    else if(collectMessageCurrentPage==1&&collectMessageTotal>collectMessagePageSize){
        //第一页并且页数大于1 左暗右亮
        $("#collect_foot_btn_prev").attr("src",contextPath+"/resources/images/CSH/last.png");
        $("#collect_foot_btn_next").attr("src",contextPath+"/resources/images/CSH/next.png");
    }
    else if(Math.ceil(div(collectMessageTotal,collectMessagePageSize))==collectMessageCurrentPage){
        //最后一页 右亮左暗
        $("#collect_foot_btn_prev").attr("src",contextPath+"/resources/images/CSH/lastCan.png");
        $("#collect_foot_btn_next").attr("src",contextPath+"/resources/images/CSH/nextNot.png");
    }else{
        //全部为亮
        $("#collect_foot_btn_prev").attr("src",contextPath+"/resources/images/CSH/lastCan.png");
        $("#collect_foot_btn_next").attr("src",contextPath+"/resources/images/CSH/next.png");
    }
    //修改页码信息
    $("#collect_page_info").text(collectMessageCurrentPage+'/'+Math.ceil(div(collectMessageTotal,collectMessagePageSize)));
}
/*分页按钮点击事件*/
$(".collect-notice-page-btn").click(function(){
    //判断方向
    var direction = "";
    if($(this).attr("id")=="collect_foot_btn_prev"){
        direction = "prev";
    }else{
        direction = "next";
    }
    changePageInfo("collectMessage",direction);
})
/*获取数据 绘制消息动态页面*/
function initCollectNoticeMessageTab(){
    //获取容器
    var container = $(".use-easy-collect-notice-item-container");//获取容器
    container.css("display","block");//一开始初始化时显示所有容器
    var obj = $("#search-collect-notice").val();//查询条件
    var url=contextPath+'/ease/system/collection/message/query?pagesize='+collectMessagePageSize+'&source_document_id='+collect_message_id+'&source_document_category='+collect_message_type+'&page='+collectMessageCurrentPage;
    if(obj!=""&&obj!=null){
        url=contextPath+'/ease/system/collection/message/query?pagesize='+collectMessagePageSize+'&source_document_id='+collect_message_id+'&source_document_category='+collect_message_type+'&noticeMessage='+obj+'&page='+collectMessageCurrentPage;
    }
    $.ajax({
        type: 'GET',
        url: url,
        contentType: "application/json; charset=utf-8",
        async:false,
        success: function (datas) {
            collectNoticeMessageDs = datas.rows;
            //绘制页面
            var diff = minus(collectMessagePageSize,datas.rows.length);//页面固定条数与查询结果条数差值
            if(diff>=0){
                for(var i=0;i<datas.rows.length;i++){
                    $(".collect-notice-item-title").eq(i).text(datas.rows[i].notice_title||'--');
                    $(".collect-notice-item-content").eq(i).text(datas.rows[i].notice_message||'--');
                    $(".collect-notice-time-detail").eq(i).text(datas.rows[i].notice_datetime||'--');
                    $(".collect-notice-item-sender").eq(i).text(datas.rows[i].userName||'--');
                }
            }
            if(diff>0){
                //隐藏没内容的container
                if(diff==collectMessagePageSize){
                    container.css("display","none");
                }else{
                    container.eq(3-diff).nextAll(".use-easy-collect-notice-item-container").css("display","none");
                }
            }
            collectMessageTotal = datas.total;
            //初始化分页按钮
            initCollectNoticePageBtn();
        }
    });
}
/*-------------------------------------------------我的设置部分---------------------*/
/*---------修改主题色部分----*/
function changeThemeColor(e){
    var color = $(e).attr("id");
    var preferences = [{
        preferences:"theme",
        preferencesValue:color
    }];
    $.ajax({
        type: "POST",
        url: contextPath+"/sys/preferences/savePreferences",
        contentType: "application/json",
        data: kendo.stringify(preferences),
        dataType: "json",
        success: function (result) {
            if (result.success) {
                kendo.ui.showInfoDialog({
                    message:'操作成功'
                }).done(function(e){
                    top.location.reload();
                })
            }else{
                kendo.ui.showErrorDialog({
                    message:result.message
                })
            }
        }
    });
}
/*--------修改密码部分------*/
var viewModelPd = kendo.observable({
    model: {},
    resetPassword: function (e) {
        var validator = $("#passwordWin").data("kendoValidator");
        if (validator.validate()) {
            Hap.request({
                type: 'POST',
                url: contextPath+"/sys/user/password/reset",
                contentType:'application/x-www-form-urlencoded',
                data: viewModelPd.model.toJSON(),
                success: function(data){
                    $("#passwordWin").data("kendoWindow").close();
                }
            })
        }
    },
    closeWin: function (e) {
        $("#passwordWin").data("kendoWindow").close();
    }
});
$(document).ready(function () {
    window.container = $("#passwordWin");
    container.kendoValidator({
        invalidMessageType: "tooltip",
        messages: {
            required: '密码为必填项',
            passwordMatch: '两次密码不一致'
        },
        rules: {
            passwordMatch: function (input) {
                if (input.is("[name=passwordAgain]") && input.val() != "") {
                    var pawd1 = $("#password");
                    return pawd1.val() == input.val();
                }
                return true;
            }
        }
    });
})
$("#passwordWin").kendoWindow({
    width: 500,
    title: '修改密码',
    resizable: false,
    visible: false,
    modal: true,
    close: function() {
        var formData = viewModelPd.model.toJSON();
        for (var k in formData) {
            viewModelPd.model.set(k, null);
        }
    }
});
$("#editPasswordBtn").click(function(){
    var passwordWinObj = $("#passwordWin");
    viewModelPd.model.userId = $("#sessionUserId").text();
    viewModelPd.model.userName = $("#sessionUserName").text().substring(3);
    var passwordWin = passwordWinObj.data("kendoWindow");
    passwordWin.refresh({template: kendo.template($("#passWdTemplate").html())});
    kendo.bind(passwordWinObj, viewModelPd);
    $('#password').attr('type', 'text');
    $('#passwordAgain').attr('type', 'text');
    passwordWin.center().open();
    $('#password').on('focus', function () {
        $(this).attr('type', 'password');
    });
    $('#passwordAgain').on('focus', function () {
        $(this).attr('type', 'password');
    });
})